
#import "GrabBag.h"
#import "nxlcau51.h"
#import <string.h>

#import "rec.h"
#import "rectbl.h"

extern Inst   rprg[PLEN];	/* rec program array          */
extern struct fptbl dtbl[];	/* rec operators & predicates */
extern char   idef[][30];	/* initially defined o & p's  */
extern char   cstr[CLEN];	/* console rec program        */

extern  int binrule[KK][KK][KK];

char   va[KK] = {'p', 'q', 'r'};

int  rec(char *z);
 
void asctobin();
int  bothof(int i, int j, int a);
int  bothtwo(int i, int j, int a, int b);
int  boththree(int i, int j, int a, int b, int c);
int  frac1(int a);
int  frac2(int a, int b);
int  frac3(int a, int b, int c);
int  frac4(int a, int b, int c, int d);
int  isab(int a, int b, int i);
int  isabc(int a, int b, int c, int i);
int  isabcd(int a, int b, int c, int d, int i);
int  qr13(int a, int b, int c, int d);
int  qr22(int a, int b, int c, int d);
int  qr211(int a, int b, int c, int d);
void runowows(char x[2][2][2], int n);
int  wolbin(int a, int b);
int  woltin(char *twn, int a, int b, int c);
void wolfin(char *hx, int a, int b, int c, int d);
int  worsruno(char ru[4][4][4]);
int  wotsruno(char ru[3][3][3]);
int  wowsruno(char ru[2][2][2]);
void w31rru(char *c, char ru[3][3][3]);
void w41rru(char *c, char ru[4][4][4]);
void wru(char *c);


int    phil;				/* length of cstr	   */
extern char   recrule[NY][CLEN];
extern char   revrule[48][CLEN];



@implementation GrabBag

/* ------------ */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - -   O R D E R   R E L A T I O N S   - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- showSubText: (char *)ch {int tl;
  tl=[subText textLength];
  [subText setSel: tl: tl];
  [subText replaceSel:  ch];
  [subText scrollSelToVisible];
  [subText display];
return self;
}

/* check the indices for all the subsets */
- subAut:sender {
asctobin();
  [self showSubText: "Subset indices:\n\n"];
  [self showSubText: "(01234) 125/125\n\n"];
  [self fours];
  [self showSubText: "\n"];
  [self threes];
  [self showSubText: "\n"];
  [self twos];
  [self showSubText: "\n"];
  [self ones];
printf("goodbye from subAut\n");
return self;
  }

/* check the four-element subsets */
- fours {
char hx[33], ch[50];
int  l;

  l= frac4(1,2,3,4);
  if (l==64) {wolfin(hx,1,2,3,4); sprintf(ch,"(1234)   %5d/64  %s\n",l,hx);}
             else sprintf(ch,"(1234)   %5d/64\n",l); 
  [self showSubText: ch];

  l= frac4(0,2,3,4);
  if (l==64) {wolfin(hx,0,2,3,4); sprintf(ch,"(0234)   %5d/64  %s\n",l,hx);}
             else sprintf(ch,"(0234)   %5d/64\n",l); 
  [self showSubText: ch];

  l= frac4(0,1,3,4);
  if (l==64) {wolfin(hx,0,1,3,4); sprintf(ch,"(0134)   %5d/64  %s\n",l,hx);}
             else sprintf(ch,"(0134)   %5d/64\n",l); 
  [self showSubText: ch];

  l= frac4(0,1,2,4);
  if (l==64) {wolfin(hx,0,1,2,4); sprintf(ch,"(0124)   %5d/64  %s\n",l,hx);}
             else sprintf(ch,"(0124)   %5d/64\n",l); 
  [self showSubText: ch];

  l= frac4(0,1,2,3);
  if (l==64) {wolfin(hx,0,1,2,3); sprintf(ch,"(0123)   %5d/64  %s\n",l,hx);}
             else sprintf(ch,"(0123)   %5d/64\n",l); 
  [self showSubText: ch];

return self;
}

/* calculate fraction of neighborhoods which conserve the evolution */
/* of a particular four element subset and report this as an index  */
int frac4(a,b,c,d) int a, b, c, d; {int k, i0, i1, i2, s[4];
k=0; s[0]=a; s[1]=b; s[2]=c; s[3]=d;
for (i0=0; i0<4; i0++)
for (i1=0; i1<4; i1++)
for (i2=0; i2<4; i2++)
  if (isabcd(a,b,c,d,binrule[s[i0]][s[i1]][s[i2]])) k++;
return k;
}

/* check membership in four-element set */
int isabcd(a,b,c,d,i) int a, b, c, d, i; {return (i==a||i==b||i==c||i==d);}

/* ascertain the Wolfram Rule Number of a four-state subautomaton */

void wolfin(hx,a,b,c,d) char* hx; int a, b, c, d; {
char ru[4][4][4], eq[KK];
int  k, i0, i1, i2, s[4];
s[0]=a; s[1]=b; s[2]=c; s[3]=d;
eq[a]='0'; eq[b]='1'; eq[c]='2'; eq[d]='3';
for (i0=0; i0<4; i0++)
for (i1=0; i1<4; i1++)
for (i2=0; i2<4; i2++){
  k=binrule[s[i0]][s[i1]][s[i2]];
  if (isabcd(a,b,c,d,k)) ru[i0][i1][i2]=eq[k];
  }
w41rru(hx,ru);
}

/* calculate wru from an argument ascii rule  */
void w41rru(c,ru) char *c, ru[4][4][4]; {
int  i, i0, i1;
for (i0=0; i0<4; i0++) for (i1=0; i1<4; i1++) {
  i= 4*(ru[i0][i1][1]-'0')+(ru[i0][i1][0]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[33-2*i0-8*i1-2]=i;
  i= 4*(ru[i0][i1][3]-'0')+(ru[i0][i1][2]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[33-2*i0-8*i1-3]=i;
  }
c[33-1]=0;
}

/* check the three-element subsets */
- threes {
char ch[40], twn[10];
int  l;

  l= frac3(2,3,4);
  if (l==27) {woltin(twn,2,3,4), sprintf(ch,"(234) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(234) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(1,2,3);
  if (l==27) {woltin(twn,1,2,3), sprintf(ch,"(123) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(123) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(1,2,4);
  if (l==27) {woltin(twn,1,2,4), sprintf(ch,"(124) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(124) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(1,3,4);
  if (l==27) {woltin(twn,1,3,4), sprintf(ch,"(134) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(134) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(0,1,2);
  if (l==27) {woltin(twn,0,1,2), sprintf(ch,"(012) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(012) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(0,1,3);
  if (l==27) {woltin(twn,0,1,3), sprintf(ch,"(013) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(013) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(0,1,4);
  if (l==27) {woltin(twn,0,1,4), sprintf(ch,"(014) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(014) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(0,2,3);
  if (l==27) {woltin(twn,0,2,3), sprintf(ch,"(023) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(023) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(0,2,4);
  if (l==27) {woltin(twn,0,2,4), sprintf(ch,"(024) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(024) %3d/ 27\n",l); 
  [self showSubText: ch];

  l= frac3(0,3,4);
  if (l==27) {woltin(twn,0,3,4), sprintf(ch,"(034) %3d/ 27  %s\n",l,twn);}
        else sprintf(ch,"(034) %3d/ 27\n",l); 
  [self showSubText: ch];

return self;
}

/* calculate fraction of neighborhoods which conserve the evolution */
/* of a particular three element subset and report this as an index */
int frac3(a,b,c) int a, b, c; {int k, i0, i1, i2, s[3];
k=0; s[0]=a; s[1]=b; s[2]=c;
for (i0=0; i0<3; i0++)
for (i1=0; i1<3; i1++)
for (i2=0; i2<3; i2++)
  if (isabc(a,b,c,binrule[s[i0]][s[i1]][s[i2]])) k++;
return k;
}

/* check membership in three-element set */
int isabc(a,b,c,i) int a, b, c, i; {return (i==a || i==b || i==c);}

/* ascertain the Wolfram Rule Number of a three-state subautomaton */

int woltin(twn,a,b,c) char *twn; int a, b, c; {
char ru[3][3][3], eq[3];
int  k, i0, i1, i2, s[3];
s[0]=a; s[1]=b; s[2]=c;
eq[a]='0'; eq[b]='1'; eq[c]='2';
for (i0=0; i0<3; i0++)
for (i1=0; i1<3; i1++)
for (i2=0; i2<3; i2++){
  k=binrule[s[i0]][s[i1]][s[i2]];
  if (isabc(a,b,c,k)) ru[i0][i1][i2]=eq[k];
  }
w31rru(twn,ru);
}

/* turn three-state ascrule into its three-state Wolfram number */
int wotsruno(ru) char ru[3][3][3]; {
int  k, i0, i1, i2;
  k=0;
  for (i0=2; i0>=0; i0--)
  for (i1=2; i1>=0; i1--)
  for (i2=2; i2>=0; i2--) {
    k=3*k+ru[i0][i1][i2]-'0';
    }
  return k;
}

/* calculate wru from an argument rule  */
void w31rru(c,ru) char *c, ru[3][3][3]; {
int  i, j;
int  i0, i1;
j=0;
for (i0=0; i0<3; i0++)
for (i1=0; i1<3; i1++)
  {
  i= 9*(ru[i0][i1][2]-'0')
    +3*(ru[i0][i1][1]-'0')
    +  (ru[i0][i1][0]-'0')
    +'0';
  if (i>'9') i=i+('A'-':');
  c[9-j-1]=i;
  j++;
  }
c[9]=0;
}

/* check the two-element subsets */
- twos {
char ch[30];
int  l;

  l= frac2(0,1);
  if (l==8) sprintf(ch,"(01)   %2d/ 8  %3d\n",l,wolbin(0,1));
        else sprintf(ch,"(01)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(0,2);
  if (l==8) sprintf(ch,"(02)   %2d/ 8  %3d\n",l,wolbin(0,2));
        else sprintf(ch,"(02)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(0,3);
  if (l==8) sprintf(ch,"(03)   %2d/ 8  %3d\n",l,wolbin(0,3));
        else sprintf(ch,"(03)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(0,4);
  if (l==8) sprintf(ch,"(04)   %2d/ 8  %3d\n",l,wolbin(0,4));
        else sprintf(ch,"(04)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(1,2);
  if (l==8) sprintf(ch,"(12)   %2d/ 8  %3d\n",l,wolbin(1,2));
        else sprintf(ch,"(12)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(1,3);
  if (l==8) sprintf(ch,"(13)   %2d/ 8  %3d\n",l,wolbin(1,3));
        else sprintf(ch,"(13)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(1,4);
  if (l==8) sprintf(ch,"(14)   %2d/ 8  %3d\n",l,wolbin(1,4));
        else sprintf(ch,"(14)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(2,3);
  if (l==8) sprintf(ch,"(23)   %2d/ 8  %3d\n",l,wolbin(2,3));
        else sprintf(ch,"(23)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(2,4);
  if (l==8) sprintf(ch,"(24)   %2d/ 8  %3d\n",l,wolbin(2,4));
        else sprintf(ch,"(24)   %2d/ 8\n",l); 
  [self showSubText: ch];

  l= frac2(3,4);
  if (l==8) sprintf(ch,"(34)   %2d/ 8  %3d\n",l,wolbin(3,4));
        else sprintf(ch,"(34)   %2d/ 8\n",l); 
  [self showSubText: ch];

return self;
}

/* calculate fraction of neighborhoods which conserve the evolution */
/* of a particular two element subset and report this as an index */

int frac2(a,b) int a, b; {int k, i0, i1, i2, s[2];
k=0; s[0]=a; s[1]=b;
for (i0=0; i0<2; i0++)
for (i1=0; i1<2; i1++)
for (i2=0; i2<2; i2++)
  if (isab(a,b,binrule[s[i0]][s[i1]][s[i2]])) k++;
return k;
}

/* check membership in two-element set */
int isab(a,b,i) int a, b, i; {return (i==a||i==b);}

/* ascertain the Wolfram Rule Number of a two-state subautomaton */

int wolbin(a,b) int a, b; {
char ru[2][2][2];
int  k, i0, i1, i2, s[2], eq[KK];
s[0]=a; s[1]=b;
eq[a]='0'; eq[b]='1';
for (i0=0; i0<2; i0++)
for (i1=0; i1<2; i1++)
for (i2=0; i2<2; i2++){
  k=binrule[s[i0]][s[i1]][s[i1]];
  if (isab(a,b,k)) ru[i0][i1][i2]=eq[k];
  }
return wowsruno(ru);
}

/* turn two-state ascrule into its two-state Wolfram number */
int wowsruno(ru) char ru[2][2][2]; {
int  k, i0, i1, i2;
  k=0;
  for (i0=1; i0>=0; i0--)
  for (i1=1; i1>=0; i1--)
  for (i2=1; i2>=0; i2--){
    k=2*k+ru[i0][i1][i2]-'0';
    }
  return k;
}

/* turn two-state Wolfram number into 2x2 ascrule */
void runowows(x,n) char x[2][2][2]; int n; {
int i, i0, i1, i2;
  i=n;
  for (i0=0; i0<2; i0++) 
  for (i1=0; i1<2; i1++) 
  for (i2=0; i2<2; i2++) {
    x[i0][i1][i2]=i%2+'0';
    i/=2;
    }
}

/* check whether one-element subset is closed */
- ones {char ch[20];
sprintf(ch,"(0)    %2d/ 1\n",frac1(0)); [self showSubText: ch];
sprintf(ch,"(1)    %2d/ 1\n",frac1(1)); [self showSubText: ch];
sprintf(ch,"(2)    %2d/ 1\n",frac1(2)); [self showSubText: ch];
sprintf(ch,"(3)    %2d/ 1\n",frac1(3)); [self showSubText: ch];
sprintf(ch,"(4)    %2d/ 1\n",frac1(4)); [self showSubText: ch];
return self;
}
 
/* calculate fraction of neighborhoods which conserve the evolution */
/* of a particular one element subset and report this as an index   */
int frac1(a) int a; {int k; k=0; if (a==binrule[a][a][a]) k++; return k;}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - -   E Q U I V A L E N C E   R E L A T I O N S   - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- showEquText: (char *)ch
{int tl;
  tl=[equText textLength];
  [equText setSel: tl: tl];
  [equText replaceSel:  ch];
  [equText scrollSelToVisible];
  [equText display];
return self;
}

/* calculate equivalence relation indices */

- equAut:sender
{
char   ch[40];
int    i, j, i0, i1, i2, i3, i4, i5, q[5], t[5];
double r[5];
asctobin();
for (i=0; i<5; i++) q[i]=t[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  i=binrule[i0][i1][i2];
  j=binrule[i3][i4][i5];
  q[0]++;
  if (eq01(i0,i3)&&eq01(i1,i4)&&eq01(i2,i5)) {t[1]++; if (eq01(i,j)) q[1]++;}
  if (eq02(i0,i3)&&eq02(i1,i4)&&eq02(i2,i5)) {t[2]++; if (eq02(i,j)) q[2]++;}
  if (eq03(i0,i3)&&eq03(i1,i4)&&eq03(i2,i5)) {t[3]++; if (eq03(i,j)) q[3]++;}
  q[4]++;
  }
r[0]=1.0;
for (i=1; i<4; i++) r[i]=((double)q[i])/((double)t[i]);
r[4]=1.0;
[self showEquText:"Equivalence indices\n"];
sprintf(ch,"(012)       %5.3f\n",r[0]); [self showEquText: ch];
if (r[1]==1.0) sprintf(ch,"(0)(12)     %5.3f,   %3d\n",r[1],qr(0,1,2));
   else sprintf(ch,"(0)(12)     %5.3f\n",r[1]);
  [self showEquText: ch];
if (r[2]==1.0) sprintf(ch,"(1)(02)     %5.3f,   %3d\n",r[2],qr(1,0,2));
   else sprintf(ch,"(1)(02)     %5.3f\n",r[2]);
  [self showEquText: ch];
if (r[3]==1.0) sprintf(ch,"(2)(01)     %5.3f,   %3d\n",r[3],qr(2,0,1));
   else sprintf(ch,"(2)(01)     %5.3f\n",r[3]);
  [self showEquText: ch];
sprintf(ch,"(0)(1)(2)   %5.3f\n",r[4]); [self showEquText: ch];
printf("goodbye from equAut\n");
return self;
}

int eq01(i,j) int i, j; {return ((i==0&&j==0)||(i!=0&&j!=0));}
int eq02(i,j) int i, j; {return ((i==1&&j==1)||(i!=1&&j!=1));}
int eq03(i,j) int i, j; {return ((i==2&&j==2)||(i!=2&&j!=2));}

int qr(a,b,c) int a, b, c; {
int i0, i1, i2, ix[3]; char ru[2][2][2];
asctobin();
ix[a]=0; ix[b]=1; ix[c]=1;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) 
  ru[ix[i0]][ix[i1]][ix[i2]]=ix[binrule[i0][i1][i2]]+'0';
return wowsruno(ru);
}

/* ------------- */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - -   G E N E R A T E   M A T H E M A T I C A   I N T E R F A C E S   - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- matica:sender 
{
char ch[60];
int  tl, gbns;
int  i, j, k, i0, i1, i2, i3, w[KK], c[KK][KK+1][KK+1];
  gbns=0;
  if (strcmp([sender title],"Groebner Basis")==0) gbns=YES;
  if (strcmp([sender title],"NSolve")==0)         gbns=NO;
// ++++++++++++++++++++++++++++++++ //
  wru(ch);
  [ruleNumber setStringValue: ch];
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK+1; i1++) for (i2=0; i2<KK+1; i2++) 
	c[i0][i1][i2]=0;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
  w[0]=w[1]=w[2]=0;
  w[i0]++; w[i1]++; w[i2]++;
  (c[binrule[i0][i1][i2]][w[0]][w[1]])++;
  }
if (gbns) sprintf(ch,"GroebnerBasis[{\n"); else sprintf(ch,"NSolve[{\n");
  tl=[groeText textLength];
  [groeText setSel: 0: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display];
for (i=0; i<KK; i++) {
  k=0;
  for (i1=0; i1<KK+1; i1++) for (i2=0; i2<KK+1; i2++) {
    if (RR < i1+i2) continue;
    j=c[i][i1][i2];
    if (j == 0) continue;
    if (k > 0) {
	 sprintf(ch," + ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (j > 1) {
	 sprintf(ch,"%d " ,j);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i1==1) {
	 sprintf(ch,"p ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i1 > 1) {
	 sprintf(ch,"p^%d ",i1);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i2==1) {
	 sprintf(ch,"q ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i2 > 1) {
	 sprintf(ch,"q^%d ",i2);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    i3=RR-i1-i2;
    if (i3==1) {
	 sprintf(ch,"r ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i3 > 1) {
	 sprintf(ch,"r^%d ",i3);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    k++;
    }
  if (gbns) sprintf(ch," - %c,\n",va[i]);
	 else sprintf(ch," - %c == 0,\n",va[i]);
  tl=[groeText textLength];
  [groeText setSel: tl: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display];
  } 
if (gbns) sprintf(ch,"p + q + r - 1\n},{p, q, r}]\n");
	else sprintf(ch,"p + q + r - 1 == 0\n},{p, q, r}]\n");
  tl=[groeText textLength];
  [groeText setSel: tl: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display];

// ++++++++++++++++++++++++++++++++ //

return self;
}

/* --------------------- B R O W S E R   D E L E G A T E ------------------- */


- (int)browser: sender fillMatrix: matrix inColumn: (int)col
{int i, n;
  n=0;
  switch (col) {
    case 0:
      for (i=0; i<4; i++) {
        [matrix addRow];
        [[matrix cellAt: i: 0] setLeaf: NO];
        [[matrix cellAt: i: 0] setLoaded: YES];
        [[matrix cellAt: i: 0] setEnabled: YES];
        }
      [[matrix cellAt: 0: 0] setStringValue: "operators"];
      [[matrix cellAt: 1: 0] setStringValue: "predefined"];
      [[matrix cellAt: 2: 0] setStringValue: "demonstrations"];
      [[matrix cellAt: 3: 0] setStringValue: "reversibles"];
      n=4;
      break;
    case 1:
      if (strcmp([[sender selectedCell] stringValue],"reversibles")==0) {
	for (i=0; i<48; i++) {
	  [matrix addRow];
	  [[matrix cellAt: i: 0] setStringValue: revrule[i]];
	  [[matrix cellAt: i: 0] setLeaf: YES];
	  [[matrix cellAt: i: 0] setLoaded: YES];
	  [[matrix cellAt: i: 0] setEnabled: YES];
	  }
	n=48;} 
      if (strcmp([[sender selectedCell] stringValue],"demonstrations")==0) {
	for (i=0; i<NY; i++) {
	  [matrix addRow];
	  [[matrix cellAt: i: 0] setStringValue: recrule[i]];
	  [[matrix cellAt: i: 0] setLeaf: YES];
	  [[matrix cellAt: i: 0] setLoaded: YES];
	  [[matrix cellAt: i: 0] setEnabled: YES];
	  }
	n=NY;} 
      if (strcmp([[sender selectedCell] stringValue],"predefined")==0) {
	for (i=0; i<1; i++) {
	  [matrix addRow];
	  [[matrix cellAt: i: 0] setStringValue: idef[i]];
	  [[matrix cellAt: i: 0] setLeaf: YES];
	  [[matrix cellAt: i: 0] setLoaded: YES];
	  [[matrix cellAt: i: 0] setEnabled: YES];
	  }
	n=1;}
      if (strcmp([[sender selectedCell] stringValue],"operators")==0) {
	for (i=0; i<95; i++) {
	  [matrix addRow];
	  [[matrix cellAt: i: 0] setStringValue: dtbl[i].r_cmnt];
	  [[matrix cellAt: i: 0] setLeaf: YES];
	  [[matrix cellAt: i: 0] setLoaded: YES];
	  [[matrix cellAt: i: 0] setEnabled: YES];
	  }
	n=95;}
      break;
    default: n=0; break;}
return n;
}

/* to distract the single click in a browser double click */
- nhul: sender {return self;}

/* - - - - - - - -   F I L E   A N D   D I R E C T O R Y   - - - - - - - - */

- setFilename:(const char *)aFilename
{
if (filename) free(filename);
filename = malloc(strlen(aFilename)+1);
strcpy(filename, aFilename);
[window setTitleAsFilename:aFilename];
return self;
}

- open:sender
{
  char *types[2] = {"rec",0};
  int  i, fd;
  NXStream *theStream;

printf("hello from open\n");
  [[OpenPanel new] allowMultipleFiles: NO];
  [[OpenPanel new] chooseDirectories: NO];

  if ([ [OpenPanel new] runModalForTypes:types]) {
    [self setFilename: [[OpenPanel new] filename]];
    fd = open(filename, O_RDONLY, 06666);
    theStream = NXOpenFile(fd, NX_READONLY);
//      NXScanf(theStream,"%s",cstr);
      i=0;
      while (NXScanf(theStream,"%c",&cstr[i])!=EOF) i++;
      phil=strlen(cstr);
    NXClose(theStream);
    close(fd);
    [window setTitleAsFilename: filename];
    [window setDocEdited:NO];
  [xtrnWin setSel: 0: [xtrnWin textLength]];
  [xtrnWin replaceSel: cstr];
  [xtrnWin scrollSelToVisible];
  [xtrnWin display];
    }

  return self;
}

- saveAs:sender
{
  id panel;
  const char *dir;
  char *file;

/* prompt user for the file name and save to that file */

  if (filename==0) {
    /* no filename; set up defaults */ 
    dir  = NXHomeDirectory();
    file = (char *)[window title];
    } else {
    file=rindex(filename,'/');
    if (file) {
      dir   = filename;
      *file = 0;
      file++;
      } else {
      dir  = filename;
      file = (char *)[window title];
      }
    }
  panel = [SavePanel new]; 
  [panel setRequiredFileType: ""];
  if ([panel runModalForDirectory: dir file: file]) {
    [self setFilename: [panel filename]];
    return [self save: sender];
    }
    return nil;  /* didn't save */
  }
    
- save:sender
{
  int      fd;
  NXStream *theStream;

  if (filename==0) return [self saveAs: sender];
  [window setTitle: "Saving ..."];

  fd = open(filename, O_WRONLY | O_CREAT | O_TRUNC, 06666);
  if (fd < 0) {
    NXRunAlertPanel(0, "Cannot save file: %s",0,0,0,strerror(errno));
    return self;
    }
  theStream = NXOpenFile(fd, NX_WRITEONLY);
  [xtrnWin writeText: theStream];
  NXClose(theStream);
  close(fd);
  [window setTitleAsFilename: filename];
  [window setDocEdited:NO];
  return self;
}

- close:sender 
{const char *fname;
int         q;
  if ([window isDocEdited])
//    fname=filename ? filename : [sender title];
//    if (rindex(fname,'/')) fname = rindex(fname,'/') + 1;
    q = NXRunAlertPanel(
      "Save",
      "Save changes to %s?",
      "Save",
      "Don't Save",
      "Cancel",
      filename);
    if (q==1) {if (![self save:nil]) return nil;}
    if(q==-1) return nil;
//  [sender setDelegate: nil];
//  [proc free];
//  [self free];
  return self;
}

- windowWillClose:sender
{
[self close: self];
printf("windowWillClose\n");
return self;
}

/* - - - - - - -  R E C   P R O G R A M   M A N A G E M E N T - - - - - - - */

- loadInternal:sender { [self loadLowerPanel: internalRECBox]; return self;}

- loadExternal:sender {[self loadLowerPanel: externalRECBox]; return self;}

- loadLowerPanel:thisRECBox 
{NXRect bxRect, loRect;
  [theBigBox getFrame: &bxRect];
  [thisRECBox getFrame: &loRect];
  [theLilBox setContentView: [thisRECBox contentView]];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [theLilBox setFrame: &loRect];
  [theBigBox display];
  [theLilBox display];
return self;
}

/* - - - - - - - - - - -  R E C   p r o g r a m s   - - - - - - - - - - */

- doRec:sender 
{
printf("hello from doRec\n");
  [value setStringValue: " "];
  if (rec([sender stringValue])) 
	[value setStringValue: "T"]; else [value setStringValue: "F"];
return self;
}

- copyAndRunREC:sender 
{
printf("hello from copyAndRunREC\n");
  if ([sender selectedColumn]==[sender lastColumn]) {
     [value setStringValue: " "];
     [execWin setStringValue: [[sender selectedCell] stringValue]];
     if (rec([execWin stringValue])) 
       [value setStringValue: "T"]; else [value setStringValue: "F"];
     [RulePanel setAllRules: self];
    }
return self;
}

- runREC:sender 
{
printf("hello from runRec\n");
  [value setStringValue: " "];
  [value setStringValue: (rec(cstr))?"T":"F"];
return self;
}

- rerunREC:sender 
{
  [xtrnWin getSubstring: cstr start: 0 length: [xtrnWin textLength]];
  [window setDocEdited:YES];
return self;
}

int rec(z) char *z; {if (rec_c(z,rprg,PLEN,dtbl)==1) return rec_x(rprg);}


@end

/* end MainView.m */